/**
 * @type {import("eslint").Linter.Config}
 */
module.exports = {
  root: true,
  env: {
    node: true,
    browser: true,
    "vue/setup-compiler-macros": true,
  },
  parser: "@typescript-eslint/parser",
  parserOptions: {
    ecmaVersion: "2022",
    sourceType: "module",
    ecmaFeatures: {
      jsx: true,
    },
    tsconfigRootDir: "./",
    project: ["tsconfig.json"],
    extraFileExtensions: [".vue"],
  },
  plugins: ["@typescript-eslint"],
  extends: [
    "eslint:recommended",
    "plugin:@typescript-eslint/recommended",
    "plugin:@typescript-eslint/recommended-requiring-type-checking",
    "plugin:vue/vue3-recommended",
    "prettier",
  ],
  rules: {
    // "vue/script-setup-uses-vars": "error",
  },
  // ignorePatterns: [".eslintrc.js"],
  overrides: [
    {
      files: ["src/**/**.vue"],
      parser: "vue-eslint-parser",
      parserOptions: {
        parser: {
          // Script parser for `<script>`
          js: "espree",

          // Script parser for `<script lang="ts">`
          ts: "@typescript-eslint/parser",

          // Script parser for vue directives (e.g. `v-if=` or `:attribute=`)
          // and vue interpolations (e.g. `{{variable}}`).
          // If not specified, the parser determined by `<script lang ="...">` is used.
          "<template>": "espree",
        },
        project: ["tsconfig.json"],
      },
      globals: {
        $ref: true,
        $computed: true,
      },
    },
  ],
};
